

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QScrollArea>
#include <QVBoxLayout>
#include <QWidget>
#include <vector>
#include "channelwidget.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = nullptr);
    ~MainWindow() override;

private slots:
    void onChannelAboutToBeTurnedOn(uint16_t deviceSerial, uint16_t channelNumber);

private:
    void enumerateDevices();
    void setupUi();

    QWidget *centralWidget;
    QVBoxLayout *mainLayout;
    QScrollArea *scrollArea;
    QWidget *scrollContent;
    QVBoxLayout *scrollLayout;

    std::vector<ChannelWidget*> channelWidgets;
};

#endif // MAINWINDOW_H

